package com.knauf.ejb.kuchenzutat;

import java.util.Collection;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * Bean implementation class for Enterprise Bean: Kuchen
 */
public abstract class KuchenBean implements javax.ejb.EntityBean {
	private javax.ejb.EntityContext myEntityCtx;
	/**
	 * setEntityContext
	 */
	public void setEntityContext(javax.ejb.EntityContext ctx) {
		myEntityCtx = ctx;
	}
	/**
	 * getEntityContext
	 */
	public javax.ejb.EntityContext getEntityContext() {
		return myEntityCtx;
	}
	/**
	 * unsetEntityContext
	 */
	public void unsetEntityContext() {
		myEntityCtx = null;
	}
	/**
	 * ejbCreate
	 */
	public java.lang.Integer ejbCreate()
		throws javax.ejb.CreateException {
		setId(this.getNextId() );
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate()
		throws javax.ejb.CreateException {
	}
	
	/**Erzeugen eines Kuchen-Objekts, wobei der Name angegeben wird. Der Key wird automatisch erzeugt.
	 * @param str_Name Der Name des Kuchens.
	 * @return Die ID des Kuchens.
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public Integer ejbCreateByName (String str_Name) throws javax.ejb.CreateException
	{
		this.setName(str_Name);

		//Key erzeugen:
		this.setId ( this.getNextId() );
		return this.getId();
	}
	
	/**Nach dem Erzeugen eines Kuchen-Objekts, wobei der Name angegeben wird: nichts besonderes zu tun.
	 * @param str_Name Der Name des Kuchens.
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public void ejbPostCreateByName (String str_Name) throws javax.ejb.CreateException
	{
	}

	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbLoad
	 */
	public void ejbLoad() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() throws javax.ejb.RemoveException {
	}
	/**
	 * ejbStore
	 */
	public void ejbStore() {
	}
	/**
	 * Get accessor for persistent attribute: id
	 */
	public abstract java.lang.Integer getId();
	/**
	 * Set accessor for persistent attribute: id
	 */
	public abstract void setId(java.lang.Integer newId);
	/**
	 * Get accessor for persistent attribute: name
	 */
	public abstract java.lang.String getName();
	/**
	 * Set accessor for persistent attribute: name
	 */
	public abstract void setName(java.lang.String newName);
	
	/**Von auen verwendbare Methode aus dem Home-Interface: Ermitteln der nchsten verfgbaren
	 * Kuchen-ID.
	 * @return Die neue Kuchen-ID, 1 grer als die maximal vorhandene ID. Wenn es keine gibt,
	 * wird "1" zurckgeliefert.
	 */
	public Integer getNextId()
	{
		Integer intMaxID = null;
		try
		{
			//Wir brauchen das Remote-Home-Interface, in dem die find-Methode definiert ist
			//wre bei einer ejbSelect-Methode nicht ntig gewesen !
			KuchenLocalHome kuchenHome = (KuchenLocalHome) this.getEntityContext().getEJBLocalHome();
			KuchenLocal kuchen = kuchenHome.findByMaxId();
			//Jetzt endlich die ID holen:
			intMaxID = (Integer) kuchen.getPrimaryKey();
		}
		catch (javax.ejb.FinderException fex)
		{
			//Finder-Exception tritt beim allerersten Abrufen auf: in diesem Fall gibt es noch
			//keinen Kuchen.
			intMaxID = null;
		}
	
		if (intMaxID == null)
	 		intMaxID = new Integer (0);
		//Um 1 erhhen:
		return new Integer (intMaxID.intValue() + 1);
	}
	/**
	 * ejbCreate
	 */
	public java.lang.Integer ejbCreate(java.lang.Integer id)
		throws javax.ejb.CreateException {
		setId(id);
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate(java.lang.Integer id)
		throws javax.ejb.CreateException {
	}
	/**
	 * This method was generated for supporting the relationship role named zutaten.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract java.util.Collection getZutaten();
	/**
	 * This method was generated for supporting the relationship role named zutaten.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setZutaten(java.util.Collection aZutaten);
	
	/**Hinzufgen einer Zutat zu den Zutaten dieses Kuchens (die einzige Business-Methode).
	 * @param zutat Die zuzufgende Zutat.
	 */
	public void addZutat (ZutatLocal zutat)
	{
		Collection collZutaten = this.getZutaten();
		collZutaten.add( zutat);
	}

	/**Abrufen der Zutatenliste.
	 * NUR hierber darf ein Client an die Zutaten kommen. "getZutaten" ist nur fr den Container ?
	 * @return Eine Liste aller Zutaten.
	 */
	public ArrayList getZutatenListe()
	{
		ArrayList list = new ArrayList();
		Iterator c = this.getZutaten().iterator();
		while (c.hasNext())
		{
		  list.add((ZutatLocal)c.next());
		}
		return list;
	}
}
