package com.knauf.ejb.kuchenzutat;
/**
 * Bean implementation class for Enterprise Bean: Zutat
 */
public abstract class ZutatBean implements javax.ejb.EntityBean {
	private javax.ejb.EntityContext myEntityCtx;
	/**
	 * setEntityContext
	 */
	public void setEntityContext(javax.ejb.EntityContext ctx) {
		myEntityCtx = ctx;
	}
	/**
	 * getEntityContext
	 */
	public javax.ejb.EntityContext getEntityContext() {
		return myEntityCtx;
	}
	/**
	 * unsetEntityContext
	 */
	public void unsetEntityContext() {
		myEntityCtx = null;
	}
	/**
	 * ejbCreate
	 */
	public java.lang.Integer ejbCreate()
		throws javax.ejb.CreateException {
		setId(this.getNextId() );
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate()
		throws javax.ejb.CreateException {
	}
	
	/**Erzeugen eines Zutat-Objekts, wobei Name und Menge angegeben wird. Der Key wird in der MEthode
	 * erzeugt.
	 * @param str_Name Der Name der Zutat
	 * @param str_Menge Die Menge der Zutat
	 * @return Immer NULL.
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public Integer ejbCreateByNameMenge (String str_Name, String str_Menge) throws javax.ejb.CreateException
	{
		this.setZutatName(str_Name);
		this.setMenge(str_Menge);
		this.setId( this.getNextId() );
	
		return this.getId();
	}
	
	/**Nach dem Erzeugen eines Zutat-Objekts, wobei Name und Menge angegeben werden: nichts besonderes zu tun.
	 * @param str_Name Der Name der Zutat.
	 * @param str_Menge Menge der Zutat
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public void ejbPostCreateByNameMenge (String str_Name, String str_Menge) throws javax.ejb.CreateException
	{
	}
	  
	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbLoad
	 */
	public void ejbLoad() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() throws javax.ejb.RemoveException {
	}
	/**
	 * ejbStore
	 */
	public void ejbStore() {
	}
	/**
	 * Get accessor for persistent attribute: id
	 */
	public abstract java.lang.Integer getId();
	/**
	 * Set accessor for persistent attribute: id
	 */
	public abstract void setId(java.lang.Integer newId);
	/**
	 * Get accessor for persistent attribute: zutatName
	 */
	public abstract java.lang.String getZutatName();
	/**
	 * Set accessor for persistent attribute: zutatName
	 */
	public abstract void setZutatName(java.lang.String newZutatName);
	/**
	 * Get accessor for persistent attribute: menge
	 */
	public abstract java.lang.String getMenge();
	/**
	 * Set accessor for persistent attribute: menge
	 */
	public abstract void setMenge(java.lang.String newMenge);
	
	/**Von auen verwendbare Methode aus dem Home-Interface: Ermitteln der nchsten verfgbaren
	 * Zutat-ID.
	 * @return Die neue Zutat-ID, 1 grer als die maximal vorhandene ID. Wenn es keine gibt,
	 * wird "1" zurckgeliefert.
	 */
	public Integer getNextId()
	{
		Integer intMaxID = null;
		try
		{
			//Wir brauchen das Remote-Home-Interface, in dem die find-Methode definiert ist
			//wre bei einer ejbSelect-Methode nicht ntig gewesen !
			ZutatLocalHome zutatHome = (ZutatLocalHome) this.getEntityContext().getEJBLocalHome();
			ZutatLocal zutat = zutatHome.findByMaxId();
			//Jetzt endlich die ID holen:
			intMaxID = (Integer) zutat.getPrimaryKey();
		}
		catch (javax.ejb.FinderException fex)
		{
			//Finder-Exception tritt beim allerersten Abrufen auf: in diesem Fall gibt es noch
			//keinen Kuchen.
			intMaxID = null;
		}

		if (intMaxID == null)
			intMaxID = new Integer (0);
		//Um 1 erhhen:
		return new Integer (intMaxID.intValue() + 1);
	}
	/**
	 * ejbCreate
	 */
	public java.lang.Integer ejbCreate(java.lang.Integer id)
		throws javax.ejb.CreateException {
		setId(id);
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate(java.lang.Integer id)
		throws javax.ejb.CreateException {
	}
	/**
	 * This method was generated for supporting the relationship role named kuchen.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract com.knauf.ejb.kuchenzutat.KuchenLocal getKuchen();
	/**
	 * This method was generated for supporting the relationship role named kuchen.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setKuchen(
		com.knauf.ejb.kuchenzutat.KuchenLocal aKuchen);

}
